Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.event
Class TreeReceiver

    java.lang.Object
      net.sf.saxon.event.SequenceReceiver
          net.sf.saxon.event.TreeReceiver

All Implemented Interfaces:
  Result, Receiver

    public class TreeReceiver

extends SequenceReceiver

A TreeReceiver acts as a bridge between a SequenceReceiver, which can receive events for constructing any kind of sequence, and an ordinary Receiver, which only handles events relating to the building of trees. To do this, it has to process any items added to the sequence using the append() interface; all other events are passed through unchanged.

If atomic items are appended to the sequence, then adjacent atomic items are turned in to a text node by converting them to strings and adding a single space as a separator.

If a document node is appended to the sequence, then the document node is ignored and its children are appended to the sequence.

If any other node is appended to the sequence, then it is pushed to the result as a sequence of Receiver events, which may involve walking recursively through the contents of a tree.

Field Summary

Fields inherited from class net.sf.saxon.event.SequenceReceiver
`pipelineConfiguration, previousAtomic, systemId`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`TreeReceiver(Receiver nextInChain)` Create a TreeReceiver

Method Summary
`void` | `append(Item item, int locationId, int copyNamespaces)` Append an arbitrary item (node or atomic value) to the output
`void` | `attribute(NodeName nameCode, SimpleType typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`void` | `characters(CharSequence chars, int locationId, int properties)` Character data
`void` | `close()` End of event sequence
`void` | `comment(CharSequence chars, int locationId, int properties)` Output a comment
`void` | `endDocument()` Notify the end of a document node
`void` | `endElement()` End of element
`Receiver` | `getUnderlyingReceiver()` Get the underlying Receiver (that is, the next one in the pipeline)
`void` | `namespace(NamespaceBinding namespaceBinding, int properties)` Notify a namespace.
`void` | `open()` Start of event sequence
`void` | `processingInstruction(String target, CharSequence data, int locationId, int properties)` Processing Instruction
`void` | `setPipelineConfiguration(PipelineConfiguration pipe)` Set the pipeline configuration
`void` | `setSystemId(String systemId)` Set the system ID
`void` | `setUnparsedEntity(String name, String uri, String publicId)` Set the URI for an unparsed entity in the document.
`void` | `startContent()` Notify the start of the content, that is, the completion of all attributes and namespaces.
`void` | `startDocument(int properties)` Start of a document node.
`void` | `startElement(NodeName nameCode, SchemaType typeCode, int locationId, int properties)` Notify the start of an element
`boolean` | `usesTypeAnnotations()` Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

Methods inherited from class net.sf.saxon.event.SequenceReceiver
`append, getConfiguration, getNamePool, getPipelineConfiguration, getSystemId`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TreeReceiver

    public TreeReceiver(Receiver nextInChain)

  Create a TreeReceiver

  Parameters:
    `nextInChain` - the receiver to which events will be directed, after expanding append events into more primitive tree-based events

Method Detail

### setSystemId

    public void setSystemId(String systemId)

  Description copied from class: `SequenceReceiver`
  Set the system ID

  Specified by:
    `setSystemId` in interface `Result`
  Specified by:
    `setSystemId` in interface `Receiver`
  Overrides:
    `setSystemId` in class `SequenceReceiver`
  Parameters:
    `systemId` - the URI used to identify the tree being passed across this interface

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Description copied from interface: `Receiver`
  Set the pipeline configuration

  Specified by:
    `setPipelineConfiguration` in interface `Receiver`
  Overrides:
    `setPipelineConfiguration` in class `SequenceReceiver`
  Parameters:
    `pipe` - the pipeline configuration

### getUnderlyingReceiver

    public Receiver getUnderlyingReceiver()

  Get the underlying Receiver (that is, the next one in the pipeline)

  Returns:
    the underlying Receiver

### open

    public void open()
              throws XPathException

  Start of event sequence

  Specified by:
    `open` in interface `Receiver`
  Overrides:
    `open` in class `SequenceReceiver`
  Throws:
    `XPathException` - if an error occurs

### close

    public void close()
               throws XPathException

  End of event sequence

  Throws:
    `XPathException` - if an error occurs

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Start of a document node.

  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

  Throws:
    `XPathException` - if an error occurs

### startElement

    public void startElement(NodeName nameCode,
                             SchemaType typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  Notify the start of an element

  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool.
    `properties` - bit-significant properties of the element node
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
  Throws:
    `XPathException` - if an error occurs

### namespace

    public void namespace(NamespaceBinding namespaceBinding,
                          int properties)
                   throws XPathException

  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element; however, duplicates may be reported. A namespace must not conflict with any namespaces already used for element or attribute names.

  Parameters:
    `namespaceBinding` - the prefix/uri pair
    `properties` - The most important property is REJECT_DUPLICATES. If this property is set, the namespace declaration will be rejected if it conflicts with a previous declaration of the same prefix. If the property is not set, the namespace declaration will be ignored if it conflicts with a previous declaration. This reflects the fact that when copying a tree, namespaces for child elements are emitted before the namespaces of their parent element. Unfortunately this conflicts with the XSLT rule for complex content construction, where the recovery action in the event of conflicts is to take the namespace that comes last. XSLT therefore doesn't recover from this error:
  Throws:
    `IllegalStateException:` - attempt to output a namespace when there is no open element start tag
    `XPathException` - if an error occurs

### attribute

    public void attribute(NodeName nameCode,
                          SimpleType typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool
    `properties` - Bit significant value. The following bits are defined:
    DISABLE_ESCAPING
  Disable escaping for this attribute
    NO_SPECIAL_CHARACTERS
  Attribute value contains no special characters
    `value` - the string value of the attribute
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
  Throws:
    `IllegalStateException:` - attempt to output an attribute when there is no open element start tag
    `XPathException` - if an error occurs

### startContent

    public void startContent()
                      throws XPathException

  Notify the start of the content, that is, the completion of all attributes and namespaces. Note that the initial receiver of output from XSLT instructions will not receive this event, it has to detect it itself. Note that this event is reported for every element even if it has no attributes, no namespaces, and no content.

  Throws:
    `XPathException` - if an error occurs

### endElement

    public void endElement()
                    throws XPathException

  End of element

  Throws:
    `XPathException` - if an error occurs

### characters

    public void characters(CharSequence chars,
                           int locationId,
                           int properties)
                    throws XPathException

  Character data

  Parameters:
    `chars` - The characters
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Bit significant value. The following bits are defined:
  DISABLE_ESCAPING
    Disable escaping for this text node
  USE_CDATA
    Output as a CDATA section
  Throws:
    `XPathException` - if an error occurs

### processingInstruction

    public void processingInstruction(String target,
                                      CharSequence data,
                                      int locationId,
                                      int properties)
                               throws XPathException

  Processing Instruction

  Parameters:
    `target` - The PI name. This must be a legal name (it will not be checked).
    `data` - The data portion of the processing instruction
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the PI.
  Throws:
    `XPathException` - if an error occurs

### comment

    public void comment(CharSequence chars,
                        int locationId,
                        int properties)
                 throws XPathException

  Output a comment

  Parameters:
    `chars` - The content of the comment
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - Additional information about the comment.
  Throws:
    `XPathException` - if an error occurs

### setUnparsedEntity

    public void setUnparsedEntity(String name,
                                  String uri,
                                  String publicId)
                           throws XPathException

  Set the URI for an unparsed entity in the document.

  Specified by:
    `setUnparsedEntity` in interface `Receiver`
  Overrides:
    `setUnparsedEntity` in class `SequenceReceiver`
  Parameters:
    `name` - The name of the unparsed entity
    `uri` - The system identifier of the unparsed entity
    `publicId` - The public identifier of the unparsed entity
  Throws:
    `XPathException` - if an error occurs

### append

    public void append(Item item,
                       int locationId,
                       int copyNamespaces)
                throws XPathException

  Append an arbitrary item (node or atomic value) to the output

  Specified by:
    `append` in class `SequenceReceiver`
  Parameters:
    `item` - the item to be appended
    `locationId` - the location of the calling instruction, for diagnostics
    `copyNamespaces` - if the item is an element node, this indicates whether its namespaces need to be copied. Values are `NodeInfo.ALL_NAMESPACES`, `NodeInfo.LOCAL_NAMESPACES`, `NodeInfo.NO_NAMESPACES`
  Throws:
    `XPathException` - if the operation fails

### usesTypeAnnotations

    public boolean usesTypeAnnotations()

  Ask whether this Receiver (or the downstream pipeline) makes any use of the type annotations supplied on element and attribute events

  Returns:
    true if the Receiver makes any use of this information. If false, the caller may supply untyped nodes instead of supplying the type annotation

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.